(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 3.3+dev4 generated code *)

let print_index pp_a ppf = function
  | a_u_i -> Unonempty_set_print.print_index pp_a ppf a_u_i

and print_uindex pp_a ppf = function
  | a_u_u -> Unonempty_set_print.print_uindex pp_a ppf a_u_u
;;

let print_domain pp_a ppf = function
  | a_u_t -> Unonempty_set_print.print_t pp_a ppf a_u_t
;;

let print_sub_domain pp_a ppf = function
  | a_u_n -> Unonempty_set_print.print_nonempty_subset pp_a ppf a_u_n
;;

let print_images pp_a ppf = function
  | Ugraph.Constant a ->
    Format.fprintf ppf "@[<1>%s@ " "Constant"; pp_a ppf a;
    Format.fprintf ppf "%,@]"
  | Ugraph.Images a_a ->
    Format.fprintf ppf "@[<1>%s@ " "Images";
    Lib_print.print_Array pp_a ppf a_a; Format.fprintf ppf "%,@]"
;;

let print_t pp_a pp_b ppf = function
  | { Ugraph.domain = a_d; Ugraph.images = b_i; } ->
    Format.fprintf ppf "%,@[<1>{@,"; Format.fprintf ppf "%,@[<1>domain =@ ";
    print_domain pp_a ppf a_d; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>images =@ "; print_images pp_b ppf b_i;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

(* End of OCamlGen, 3.3+dev4 generated code *)
