(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 3.3+dev4 generated code *)

let print_xml_uindex px_a ppf = function
  | a_u_i -> Uuniverse_print_xml.print_xml_index px_a ppf a_u_i
;;

let print_xml_index px_a ppf = function
  | a_u_u -> print_xml_uindex (print_xml_uindex px_a) ppf a_u_u
;;

let print_xml_t px_a ppf = function
  | { Unonempty_set.universe = a_u_t; Unonempty_set.uindices = a_u_u_t; } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Uuniverse_print_xml.print_xml_t px_a ppf a_u_t; Format.fprintf ppf "%,;";
    Uuniverse_print_xml.print_xml_t (print_xml_uindex px_a) ppf a_u_u_t;
    Format.fprintf ppf "%,;"; Format.fprintf ppf "%,@,}@]"
;;

let print_xml_nonempty_subset px_a ppf = function
  | {
      Unonempty_set.support = a_t;
      Unonempty_set.indices = a_i_a;
      Unonempty_set.nonempty_set = a_t0;
    } ->
    Format.fprintf ppf "%,@[<1>{@,"; print_xml_t px_a ppf a_t;
    Format.fprintf ppf "%,;";
    Lib_print_xml.print_xml_Array (print_xml_index px_a) ppf a_i_a;
    Format.fprintf ppf "%,;"; print_xml_t px_a ppf a_t0;
    Format.fprintf ppf "%,;"; Format.fprintf ppf "%,@,}@]"
;;

let print_xml_dichotomy px_a ppf = function
  | (a_n, a_n0) ->
    Format.fprintf ppf "%,@[<1>"; print_xml_nonempty_subset px_a ppf a_n;
    Format.fprintf ppf "%,@ "; print_xml_nonempty_subset px_a ppf a_n0;
    Format.fprintf ppf "%,@]"
;;

(* End of OCamlGen, 3.3+dev4 generated code *)
