(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of ocamlprint_xmlc.bin generated code *)

let print_xml_nonempty_range ppf = function
  | {
      Upositive_rational_range_types.left = u_t;
      Upositive_rational_range_types.right = u_t0;
    } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Upositive_rational_print_xml.print_xml_t ppf u_t;
    Format.fprintf ppf "%,;";
    Upositive_rational_print_xml.print_xml_t ppf u_t0;
    Format.fprintf ppf "%,;"; Format.fprintf ppf "%,@,}@]"
;;

let print_xml_t ppf = function
  | Upositive_rational_range_types.Empty ->
    Format.fprintf ppf "%s" "<Empty/>"
  | Upositive_rational_range_types.Nonempty n ->
    Format.fprintf ppf "@[<1>%s@," "<Nonempty>";
    print_xml_nonempty_range ppf n; Format.fprintf ppf "%,</Nonempty>";
    Format.fprintf ppf "%,@]"
;;

(* End of ocamlprint_xmlc.bin generated code *)
