(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: umatrix_types.ml,v 1.8 2014/02/09 17:27:28 fclement Exp $ *)

(* The private type of matrices. *)

let mt_qual = Upervasives.qualify "Umatrix";;

let mt_failwith = Upervasives.failwith_qual mt_qual;;

type 'a matrix = 'a array array;;

let to_matrix aa =
  let ni = Array.length aa in
  if ni > 0 then begin
    let nj = Array.length (Array.unsafe_get aa 0) in
    for i = 1 to ni - 1 do
      if Array.length (Array.unsafe_get aa i) <> nj then
        mt_failwith "of_array_array" "non rectangular argument";
    done; end;
  aa
;;

external of_matrix : 'a matrix -> 'a array array = "%identity";;
